module Fourmi::Prawn::Utils
  module Extensions
    module StrokesAndColors
      def with_fill_color(color)
        original_color = fill_color
        self.fill_color = color

        yield if block_given?
      ensure
        self.fill_color = original_color
      end

      def with_stroke_properties(color: nil, width: nil)
        original_color = stroke_color
        original_width = line_width

        self.stroke_color = color unless color.nil?
        self.line_width = width unless width.nil?

        yield if block_given?
      ensure
        self.stroke_color = original_color
        self.line_width = original_width
      end
    end
  end
end

require 'prawn/document'
Prawn::Document.extensions << Fourmi::Prawn::Utils::Extensions::StrokesAndColors
